/* Copyright (C) 2015-2022 Swift Navigation Inc.
 * Contact: https://support.swiftnav.com
 *
 * This source is subject to the license found in the file 'LICENSE' which must
 * be be distributed together with this source. All other rights reserved.
 *
 * THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package com.swiftnav.sbp.flash;

// This file was auto-generated from yaml/swiftnav/sbp/flash.yaml by generate.py.
// Do not modify by hand!


import com.swiftnav.sbp.SBPBinaryException;
import com.swiftnav.sbp.SBPMessage;
import org.json.JSONObject;

/**
 * SBP class for message MSG_FLASH_DONE (0x00E0).
 *
 * <p>You can have MSG_FLASH_DONE inherent its fields directly from an inherited SBP object, or
 * construct it inline using a dict of its fields.
 *
 * <p>This message defines success or failure codes for a variety of flash memory requests from the
 * host to the device. Flash read and write messages, such as MSG_FLASH_READ_REQ, or
 * MSG_FLASH_PROGRAM, may return this message on failure.
 */
public class MsgFlashDone extends SBPMessage {
    public static final int TYPE = 0x00E0;

    /** Response flags */
    public int response;

    public MsgFlashDone(int sender) {
        super(sender, TYPE);
    }

    public MsgFlashDone() {
        super(TYPE);
    }

    public MsgFlashDone(SBPMessage msg) throws SBPBinaryException {
        super(msg);
        if (msg.type != TYPE)
            throw new SBPBinaryException(
                    "Type mismatch for MsgFlashDone, expected 224, actual " + msg.type);
    }

    @Override
    protected void parse(Parser parser) throws SBPBinaryException {
        /* Parse fields from binary */
        response = parser.getU8();
    }

    @Override
    protected void build(Builder builder) {
        builder.putU8(response);
    }

    @Override
    public JSONObject toJSON() {
        JSONObject obj = super.toJSON();
        obj.put("response", response);
        return obj;
    }

    @Override
    public String getFriendlyName() {
        return "FLASH DONE";
    }
}
