/* Copyright (C) 2015-2022 Swift Navigation Inc.
 * Contact: https://support.swiftnav.com
 *
 * This source is subject to the license found in the file 'LICENSE' which must
 * be be distributed together with this source. All other rights reserved.
 *
 * THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package com.swiftnav.sbp.observation;

// This file was auto-generated from yaml/swiftnav/sbp/observation.yaml by generate.py.
// Do not modify by hand!


import com.swiftnav.sbp.SBPBinaryException;
import com.swiftnav.sbp.SBPMessage;
import com.swiftnav.sbp.gnss.*;
import org.json.JSONObject;

/**
 * SBP class for message MSG_GNSS_CAPB (0x0096).
 *
 * <p>You can have MSG_GNSS_CAPB inherent its fields directly from an inherited SBP object, or
 * construct it inline using a dict of its fields.
 *
 * <p>Bit masks of signal capabilities for each GNSS satellite PRN. Please see ICD-GPS-200 (Chapter
 * 20.3.3.5.1.4) for more details.
 */
public class MsgGnssCapb extends SBPMessage {
    public static final int TYPE = 0x0096;

    /** Navigation Message Correction Table Validity Time */
    public GPSTimeSec t_nmct;

    /** GNSS capabilities masks */
    public GnssCapb gc;

    public MsgGnssCapb(int sender) {
        super(sender, TYPE);
    }

    public MsgGnssCapb() {
        super(TYPE);
    }

    public MsgGnssCapb(SBPMessage msg) throws SBPBinaryException {
        super(msg);
        if (msg.type != TYPE)
            throw new SBPBinaryException(
                    "Type mismatch for MsgGnssCapb, expected 150, actual " + msg.type);
    }

    @Override
    protected void parse(Parser parser) throws SBPBinaryException {
        /* Parse fields from binary */
        t_nmct = new GPSTimeSec().parse(parser);
        gc = new GnssCapb().parse(parser);
    }

    @Override
    protected void build(Builder builder) {
        t_nmct.build(builder);
        gc.build(builder);
    }

    @Override
    public JSONObject toJSON() {
        JSONObject obj = super.toJSON();
        obj.put("t_nmct", t_nmct.toJSON());
        obj.put("gc", gc.toJSON());
        return obj;
    }

    @Override
    public String getFriendlyName() {
        return "GNSS CAPB";
    }
}
