/* Copyright (C) 2015-2022 Swift Navigation Inc.
 * Contact: https://support.swiftnav.com
 *
 * This source is subject to the license found in the file 'LICENSE' which must
 * be be distributed together with this source. All other rights reserved.
 *
 * THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package com.swiftnav.sbp.test;

// This file was auto-generated from
// spec/tests/yaml/swiftnav/sbp/system/test_MsgCsacTelemetryLabels.yaml by generate.py. Do not
// modify by hand!


import com.swiftnav.sbp.SBPMessage;
import com.swiftnav.sbp.system.MsgCsacTelemetryLabels;
import java.math.BigInteger;
import org.json.JSONObject;
import org.junit.Test;

public class auto_check_sbp_system_MsgCsacTelemetryLabelsTest {

    public static boolean debug = false;
    private static final double DELTA = 1e-15;

    @Test
    public void test1() throws Throwable {
        if (debug)
            System.out.format("%n%s%n", "auto_check_sbp_system_MsgCsacTelemetryLabelsTest.test1");
        byte[] payload =
                new byte[] {
                    (byte) 186, (byte) 115, (byte) 111, (byte) 109, (byte) 101, (byte) 32,
                    (byte) 108, (byte) 97, (byte) 98, (byte) 101, (byte) 108, (byte) 115,
                };
        SBPMessage sbp = new SBPMessage(0xc85b, 0xff05, payload);
        MsgCsacTelemetryLabels msg = new MsgCsacTelemetryLabels(sbp);
        JSONObject json = msg.toJSON();
        Number value;
        Number expected;
        value = msg.id;
        if (value instanceof BigInteger) {
            org.junit.Assert.assertTrue(
                    "'" + msg.id + "' != '" + 186 + "'", value.equals(BigInteger.valueOf(186L)));
        } else {
            value = value.longValue();
            expected = 186L;
            org.junit.Assert.assertEquals(value, expected);
        }
        org.junit.Assert.assertEquals(msg.telemetry_labels, "some labels");

        org.junit.Assert.assertNotEquals("", msg.getFriendlyName());
    }
}
