#!/usr/bin/perl -w
#
# Copyright (C) 2015-2023 Swift Navigation Inc.
# Contact: https://support.swiftnav.com
#
# This source is subject to the license found in the file 'LICENSE' which must
# be be distributed together with this source. All other rights reserved.
#
# THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
# EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
#
# Test cases automatically generated from spec/tests/yaml/swiftnav/sbp/observation/test_MsgBasePosEcef.yaml
# with generate.py.  Do not modify by hand!

use strict;

BEGIN {
    # add grandparent directory to include path
    use Cwd qw(realpath);
    use File::Basename;
    unshift @INC, realpath(dirname($0))."/../../";
}

use KaitaiSbp::Sbp;
use KaitaiSbp::ParseUtils;
use IO::KaitaiStruct;
use Test::More;
use JSON::PP;
use MIME::Base64;
sub test_auto_check_sbp_observation_msg_base_pos_ecef_1() {
    my $buf = decode_base64("VUgAAAAY5IOe9VfNRMFCPujRIHZQwdXnavs/FE1Bwn0=");
    my $stream = IO::KaitaiStruct::Stream->new($buf);
    my $msg = ParseUtils::get_flattened_msg(Sbp::SbpMessage->new($stream));
    
    is($msg->{'crc'}, 0x7dc2, "crc");
    
    is($msg->{'length'}, 24, "length");
    
    is($msg->{'payload'}, "5IOe9VfNRMFCPujRIHZQwdXnavs/FE1B", "payload");
    
    is($msg->{'msg_type'}, 0x48, "msg_type");
    
    is($msg->{'preamble'}, 0x55, "preamble");
    
    is($msg->{'sender'}, 0, "sender");

    my $json = JSON::PP->new->convert_blessed->canonical;
    
    is($msg->x(), -2726575.9189, "x");
    
    is($msg->y(), -4315267.2798, "y");
    
    is($msg->z(), 3811455.9642, "z");

    is($json->encode($msg), $json->encode($json->decode(q{{"crc":32194,"length":24,"msg_type":72,"payload":"5IOe9VfNRMFCPujRIHZQwdXnavs/FE1B","preamble":85,"sender":0,"x":-2726575.9189,"y":-4315267.2798,"z":3811455.9642}})), "raw_json");
}
test_auto_check_sbp_observation_msg_base_pos_ecef_1();

done_testing();