# Copyright (C) 2015-2023 Swift Navigation Inc.
# Contact: https://support.swiftnav.com
#
# This source is subject to the license found in the file 'LICENSE' which must
# be be distributed together with this source. All other rights reserved.
#
# THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
# EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
#
# Test cases automatically generated from spec/tests/yaml/swiftnav/sbp/navigation/test_MsgPosECEFCovGNSS.yaml
# with generate.py.  Do not modify by hand!

import kaitai_sbp.sbp as sbp
from kaitai_sbp.parse_utils import get_flattened_msg
from kaitai_sbp.tests.utils import dictify
from kaitaistruct import KaitaiStream
import io
import base64

def test_auto_check_sbp_navigation_msg_pos_ecef_cov_gnss_1():
    buf = base64.standard_b64decode("VTQCABA2GOXpHTT+ntoqjkTBRaJZWyJEUMGDFbCB765NQZ7oHjza3RQ8gYjGu814pjwFpiO8erFzPBIEn2Y=")

    stream = KaitaiStream(io.BytesIO(buf))
    msg = get_flattened_msg(sbp.Sbp.SbpMessage(stream))
    
    assert msg.crc == 0x669f
    
    assert msg.length == 54
    
    assert msg.msg_type == 0x234
    
    assert msg.payload == "GOXpHTT+ntoqjkTBRaJZWyJEUMGDFbCB765NQZ7oHjza3RQ8gYjGu814pjwFpiO8erFzPBIE"
    
    assert msg.preamble == 0x55
    
    assert msg.sender == 0x1000
    
    assert dictify(msg.cov_x_x) == 0.009699014946818352
    
    assert dictify(msg.cov_x_y) == 0.009086096659302711
    
    assert dictify(msg.cov_x_z) == -0.006058753002434969
    
    assert dictify(msg.cov_y_y) == 0.020321274176239967
    
    assert dictify(msg.cov_y_z) == -0.009988312609493732
    
    assert dictify(msg.cov_z_z) == 0.01487385667860508
    
    assert dictify(msg.flags) == 4
    
    assert dictify(msg.n_sats) == 18
    
    assert dictify(msg.tow) == 501867800
    
    assert dictify(msg.x) == -2694229.7079770807
    
    assert dictify(msg.y) == -4264073.427345817
    
    assert dictify(msg.z) == 3890655.013186158

    assert dictify(msg) == {'tow': 501867800, 'x': -2694229.7079770807, 'y': -4264073.427345817, 'z': 3890655.013186158, 'cov_x_x': 0.009699014946818352, 'cov_x_y': 0.009086096659302711, 'cov_x_z': -0.006058753002434969, 'cov_y_y': 0.020321274176239967, 'cov_y_z': -0.009988312609493732, 'cov_z_z': 0.01487385667860508, 'n_sats': 18, 'flags': 4, 'preamble': 85, 'msg_type': 564, 'sender': 4096, 'payload': 'GOXpHTT+ntoqjkTBRaJZWyJEUMGDFbCB765NQZ7oHjza3RQ8gYjGu814pjwFpiO8erFzPBIE', 'crc': 26271, 'length': 54}