//
// Copyright (C) 2019-2021 Swift Navigation Inc.
// Contact: https://support.swiftnav.com
//
// This source is subject to the license found in the file 'LICENSE' which must
// be be distributed together with this source. All other rights reserved.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

// This file was auto-generated from spec/tests/yaml/swiftnav/sbp/observation/test_MsgGroupDelayDepA.yaml by generate.py. Do not modify by hand!

use crate::*;

/// Tests [`sbp::iter_messages`], from payload into SBP messages
///
/// Asserts:
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
fn test_auto_check_sbp_observation_msg_group_delay_dep_a() {
    {
        let mut payload = Cursor::new(vec![
            85, 146, 0, 123, 0, 14, 176, 207, 6, 0, 106, 8, 22, 1, 254, 253, 165, 255, 237, 23,
            162, 91,
        ]);

        // Test the round trip payload parsing
        let sbp_msg = {
            let mut msgs = iter_messages(&mut payload);
            msgs.next()
                .expect("no message found")
                .expect("failed to parse message")
        };
        match &sbp_msg {
            sbp::messages::Sbp::MsgGroupDelayDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x92,
                    "Incorrect message type, expected 0x92, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x007b,
                    "incorrect sender id, expected 0x007b, is {sender_id}"
                );
                assert_eq!(
                    msg.isc_l1ca, -91,
                    "incorrect value for isc_l1ca, expected -91, is {}",
                    msg.isc_l1ca
                );
                assert_eq!(
                    msg.isc_l2c, 6125,
                    "incorrect value for isc_l2c, expected 6125, is {}",
                    msg.isc_l2c
                );
                assert_eq!(
                    msg.prn, 22,
                    "incorrect value for prn, expected 22, is {}",
                    msg.prn
                );
                assert_eq!(
                    msg.t_op.tow, 446384,
                    "incorrect value for t_op.tow, expected 446384, is {}",
                    msg.t_op.tow
                );
                assert_eq!(
                    msg.t_op.wn, 2154,
                    "incorrect value for t_op.wn, expected 2154, is {}",
                    msg.t_op.wn
                );
                assert_eq!(
                    msg.tgd, -514,
                    "incorrect value for tgd, expected -514, is {}",
                    msg.tgd
                );
                assert_eq!(
                    msg.valid, 1,
                    "incorrect value for valid, expected 1, is {}",
                    msg.valid
                );
            }
            _ => panic!("Invalid message type! Expected a MsgGroupDelayDepA"),
        };
        let frame = sbp::to_vec(&sbp_msg).unwrap();
        assert_eq!(frame, payload.into_inner());
    }
}

/// Tests [`sbp::json::iter_messages`] for JSON payload -> SBP message
/// and [`sbp::json::iter_messages_from_fields`] for JSON fields -> SBP message.
///
/// Asserts:
/// -   SBP message constructed via payload is identical to from fields
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
#[cfg(feature = "json")]
fn test_json2sbp_auto_check_sbp_observation_msg_group_delay_dep_a() {
    {
        let json_input = r#"{"crc":23458,"length":14,"msg_type":146,"payload":"sM8GAGoIFgH+/aX/7Rc=","preamble":85,"sender":123,"t_op":{"tow":446384,"wn":2154},"prn":22,"valid":1,"tgd":-514,"isc_l1ca":-91,"isc_l2c":6125}"#.as_bytes();

        let sbp_msg = {
            // JSON to SBP message from payload
            let mut iter = json2sbp_iter_msg(json_input);
            let from_payload = iter
                .next()
                .expect("no message found")
                .expect("failed to parse message");

            // JSON to SBP message from fields
            let mut iter = iter_messages_from_fields(json_input);
            let from_fields = iter
                .next()
                .expect("no message found")
                .expect("failed to parse message");

            assert_eq!(from_fields, from_payload);
            from_fields
        };
        match &sbp_msg {
            sbp::messages::Sbp::MsgGroupDelayDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x92,
                    "Incorrect message type, expected 0x92, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x007b,
                    "incorrect sender id, expected 0x007b, is {sender_id}"
                );
                assert_eq!(
                    msg.isc_l1ca, -91,
                    "incorrect value for isc_l1ca, expected -91, is {}",
                    msg.isc_l1ca
                );
                assert_eq!(
                    msg.isc_l2c, 6125,
                    "incorrect value for isc_l2c, expected 6125, is {}",
                    msg.isc_l2c
                );
                assert_eq!(
                    msg.prn, 22,
                    "incorrect value for prn, expected 22, is {}",
                    msg.prn
                );
                assert_eq!(
                    msg.t_op.tow, 446384,
                    "incorrect value for t_op.tow, expected 446384, is {}",
                    msg.t_op.tow
                );
                assert_eq!(
                    msg.t_op.wn, 2154,
                    "incorrect value for t_op.wn, expected 2154, is {}",
                    msg.t_op.wn
                );
                assert_eq!(
                    msg.tgd, -514,
                    "incorrect value for tgd, expected -514, is {}",
                    msg.tgd
                );
                assert_eq!(
                    msg.valid, 1,
                    "incorrect value for valid, expected 1, is {}",
                    msg.valid
                );
            }
            _ => panic!("Invalid message type! Expected a MsgGroupDelayDepA"),
        };
    }
}

/// Tests [`sbp::json::JsonEncoder`] for roundtrip SBP message -> JSON
///
/// Assumes:
/// -   [`self::test_auto_check_sbp_observation_msg_group_delay_dep_a`] passes
///
/// Asserts:
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
#[cfg(feature = "json")]
fn test_sbp2json_auto_check_sbp_observation_msg_group_delay_dep_a() {
    {
        let mut payload = Cursor::new(vec![
            85, 146, 0, 123, 0, 14, 176, 207, 6, 0, 106, 8, 22, 1, 254, 253, 165, 255, 237, 23,
            162, 91,
        ]);

        // Construct sbp message
        let sbp_msg = {
            let mut msgs = iter_messages(&mut payload);
            msgs.next()
                .expect("no message found")
                .expect("failed to parse message")
        };

        let mut json_buffer = vec![];
        // Populate json buffer, CompactFormatter
        sbp::json::JsonEncoder::new(&mut json_buffer, sbp::json::CompactFormatter {})
            .send(&sbp_msg)
            .unwrap();

        // Reconstruct Sbp message from json fields, roundtrip
        let sbp_msg = sbp::messages::Sbp::MsgGroupDelayDepA(
            serde_json::from_str(
                std::str::from_utf8(json_buffer.as_slice())
                    .unwrap()
                    .to_string()
                    .as_str(),
            )
            .unwrap(),
        );
        match &sbp_msg {
            sbp::messages::Sbp::MsgGroupDelayDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x92,
                    "Incorrect message type, expected 0x92, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x007b,
                    "incorrect sender id, expected 0x007b, is {sender_id}"
                );
                assert_eq!(
                    msg.isc_l1ca, -91,
                    "incorrect value for isc_l1ca, expected -91, is {}",
                    msg.isc_l1ca
                );
                assert_eq!(
                    msg.isc_l2c, 6125,
                    "incorrect value for isc_l2c, expected 6125, is {}",
                    msg.isc_l2c
                );
                assert_eq!(
                    msg.prn, 22,
                    "incorrect value for prn, expected 22, is {}",
                    msg.prn
                );
                assert_eq!(
                    msg.t_op.tow, 446384,
                    "incorrect value for t_op.tow, expected 446384, is {}",
                    msg.t_op.tow
                );
                assert_eq!(
                    msg.t_op.wn, 2154,
                    "incorrect value for t_op.wn, expected 2154, is {}",
                    msg.t_op.wn
                );
                assert_eq!(
                    msg.tgd, -514,
                    "incorrect value for tgd, expected -514, is {}",
                    msg.tgd
                );
                assert_eq!(
                    msg.valid, 1,
                    "incorrect value for valid, expected 1, is {}",
                    msg.valid
                );
            }
            _ => panic!("Invalid message type! Expected a MsgGroupDelayDepA"),
        };

        // Check payload is still identical
        let frame = sbp::to_vec(&sbp_msg).unwrap();
        assert_eq!(frame, payload.into_inner());
    }
}
