//
// Copyright (C) 2019-2021 Swift Navigation Inc.
// Contact: https://support.swiftnav.com
//
// This source is subject to the license found in the file 'LICENSE' which must
// be be distributed together with this source. All other rights reserved.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

// This file was auto-generated from spec/tests/yaml/swiftnav/sbp/ssr/test_MsgSsrTileDefinitionDepA.yaml by generate.py. Do not modify by hand!

use crate::*;

/// Tests [`sbp::iter_messages`], from payload into SBP messages
///
/// Asserts:
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
fn test_auto_check_sbp_ssr_msg_ssr_tile_definition_dep_a() {
    {
        let mut payload = Cursor::new(vec![
            85, 246, 5, 200, 133, 24, 57, 190, 178, 247, 8, 185, 9, 181, 162, 240, 65, 19, 255,
            143, 21, 191, 239, 205, 171, 0, 0, 0, 0, 0, 65, 154,
        ]);

        // Test the round trip payload parsing
        let sbp_msg = {
            let mut msgs = iter_messages(&mut payload);
            msgs.next()
                .expect("no message found")
                .expect("failed to parse message")
        };
        match &sbp_msg {
            sbp::messages::Sbp::MsgSsrTileDefinitionDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x5f6,
                    "Incorrect message type, expected 0x5f6, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x85c8,
                    "incorrect sender id, expected 0x85c8, is {sender_id}"
                );
                assert_eq!(
                    msg.bitmask, 11259375,
                    "incorrect value for bitmask, expected 11259375, is {}",
                    msg.bitmask
                );
                assert_eq!(
                    msg.cols, 48917,
                    "incorrect value for cols, expected 48917, is {}",
                    msg.cols
                );
                assert_eq!(
                    msg.corner_nw_lat, -18168,
                    "incorrect value for corner_nw_lat, expected -18168, is {}",
                    msg.corner_nw_lat
                );
                assert_eq!(
                    msg.corner_nw_lon, -19191,
                    "incorrect value for corner_nw_lon, expected -19191, is {}",
                    msg.corner_nw_lon
                );
                assert_eq!(
                    msg.rows, 36863,
                    "incorrect value for rows, expected 36863, is {}",
                    msg.rows
                );
                assert_eq!(
                    msg.spacing_lat, 61602,
                    "incorrect value for spacing_lat, expected 61602, is {}",
                    msg.spacing_lat
                );
                assert_eq!(
                    msg.spacing_lon, 4929,
                    "incorrect value for spacing_lon, expected 4929, is {}",
                    msg.spacing_lon
                );
                assert_eq!(
                    msg.tile_id, 63410,
                    "incorrect value for tile_id, expected 63410, is {}",
                    msg.tile_id
                );
                assert_eq!(
                    msg.tile_set_id, 48697,
                    "incorrect value for tile_set_id, expected 48697, is {}",
                    msg.tile_set_id
                );
            }
            _ => panic!("Invalid message type! Expected a MsgSsrTileDefinitionDepA"),
        };
        let frame = sbp::to_vec(&sbp_msg).unwrap();
        assert_eq!(frame, payload.into_inner());
    }
}

/// Tests [`sbp::json::iter_messages`] for JSON payload -> SBP message
/// and [`sbp::json::iter_messages_from_fields`] for JSON fields -> SBP message.
///
/// Asserts:
/// -   SBP message constructed via payload is identical to from fields
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
#[cfg(feature = "json")]
fn test_json2sbp_auto_check_sbp_ssr_msg_ssr_tile_definition_dep_a() {
    {
        let json_input = r#"{"crc":39489,"length":24,"msg_type":1526,"payload":"Ob6y9wi5CbWi8EET/48Vv+/NqwAAAAAA","preamble":85,"sender":34248,"tile_set_id":48697,"tile_id":63410,"corner_nw_lat":-18168,"corner_nw_lon":-19191,"spacing_lat":61602,"spacing_lon":4929,"rows":36863,"cols":48917,"bitmask":11259375}"#.as_bytes();

        let sbp_msg = {
            // JSON to SBP message from payload
            let mut iter = json2sbp_iter_msg(json_input);
            let from_payload = iter
                .next()
                .expect("no message found")
                .expect("failed to parse message");

            // JSON to SBP message from fields
            let mut iter = iter_messages_from_fields(json_input);
            let from_fields = iter
                .next()
                .expect("no message found")
                .expect("failed to parse message");

            assert_eq!(from_fields, from_payload);
            from_fields
        };
        match &sbp_msg {
            sbp::messages::Sbp::MsgSsrTileDefinitionDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x5f6,
                    "Incorrect message type, expected 0x5f6, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x85c8,
                    "incorrect sender id, expected 0x85c8, is {sender_id}"
                );
                assert_eq!(
                    msg.bitmask, 11259375,
                    "incorrect value for bitmask, expected 11259375, is {}",
                    msg.bitmask
                );
                assert_eq!(
                    msg.cols, 48917,
                    "incorrect value for cols, expected 48917, is {}",
                    msg.cols
                );
                assert_eq!(
                    msg.corner_nw_lat, -18168,
                    "incorrect value for corner_nw_lat, expected -18168, is {}",
                    msg.corner_nw_lat
                );
                assert_eq!(
                    msg.corner_nw_lon, -19191,
                    "incorrect value for corner_nw_lon, expected -19191, is {}",
                    msg.corner_nw_lon
                );
                assert_eq!(
                    msg.rows, 36863,
                    "incorrect value for rows, expected 36863, is {}",
                    msg.rows
                );
                assert_eq!(
                    msg.spacing_lat, 61602,
                    "incorrect value for spacing_lat, expected 61602, is {}",
                    msg.spacing_lat
                );
                assert_eq!(
                    msg.spacing_lon, 4929,
                    "incorrect value for spacing_lon, expected 4929, is {}",
                    msg.spacing_lon
                );
                assert_eq!(
                    msg.tile_id, 63410,
                    "incorrect value for tile_id, expected 63410, is {}",
                    msg.tile_id
                );
                assert_eq!(
                    msg.tile_set_id, 48697,
                    "incorrect value for tile_set_id, expected 48697, is {}",
                    msg.tile_set_id
                );
            }
            _ => panic!("Invalid message type! Expected a MsgSsrTileDefinitionDepA"),
        };
    }
}

/// Tests [`sbp::json::JsonEncoder`] for roundtrip SBP message -> JSON
///
/// Assumes:
/// -   [`self::test_auto_check_sbp_ssr_msg_ssr_tile_definition_dep_a`] passes
///
/// Asserts:
/// -   SBP fields equates to that of the field
/// -   Payload is identical
#[test]
#[cfg(feature = "json")]
fn test_sbp2json_auto_check_sbp_ssr_msg_ssr_tile_definition_dep_a() {
    {
        let mut payload = Cursor::new(vec![
            85, 246, 5, 200, 133, 24, 57, 190, 178, 247, 8, 185, 9, 181, 162, 240, 65, 19, 255,
            143, 21, 191, 239, 205, 171, 0, 0, 0, 0, 0, 65, 154,
        ]);

        // Construct sbp message
        let sbp_msg = {
            let mut msgs = iter_messages(&mut payload);
            msgs.next()
                .expect("no message found")
                .expect("failed to parse message")
        };

        let mut json_buffer = vec![];
        // Populate json buffer, CompactFormatter
        sbp::json::JsonEncoder::new(&mut json_buffer, sbp::json::CompactFormatter {})
            .send(&sbp_msg)
            .unwrap();

        // Reconstruct Sbp message from json fields, roundtrip
        let sbp_msg = sbp::messages::Sbp::MsgSsrTileDefinitionDepA(
            serde_json::from_str(
                std::str::from_utf8(json_buffer.as_slice())
                    .unwrap()
                    .to_string()
                    .as_str(),
            )
            .unwrap(),
        );
        match &sbp_msg {
            sbp::messages::Sbp::MsgSsrTileDefinitionDepA(msg) => {
                let msg_type = msg.message_type().unwrap();
                assert_eq!(
                    msg_type, 0x5f6,
                    "Incorrect message type, expected 0x5f6, is {}",
                    msg_type
                );
                let sender_id = msg.sender_id().unwrap();
                assert_eq!(
                    sender_id, 0x85c8,
                    "incorrect sender id, expected 0x85c8, is {sender_id}"
                );
                assert_eq!(
                    msg.bitmask, 11259375,
                    "incorrect value for bitmask, expected 11259375, is {}",
                    msg.bitmask
                );
                assert_eq!(
                    msg.cols, 48917,
                    "incorrect value for cols, expected 48917, is {}",
                    msg.cols
                );
                assert_eq!(
                    msg.corner_nw_lat, -18168,
                    "incorrect value for corner_nw_lat, expected -18168, is {}",
                    msg.corner_nw_lat
                );
                assert_eq!(
                    msg.corner_nw_lon, -19191,
                    "incorrect value for corner_nw_lon, expected -19191, is {}",
                    msg.corner_nw_lon
                );
                assert_eq!(
                    msg.rows, 36863,
                    "incorrect value for rows, expected 36863, is {}",
                    msg.rows
                );
                assert_eq!(
                    msg.spacing_lat, 61602,
                    "incorrect value for spacing_lat, expected 61602, is {}",
                    msg.spacing_lat
                );
                assert_eq!(
                    msg.spacing_lon, 4929,
                    "incorrect value for spacing_lon, expected 4929, is {}",
                    msg.spacing_lon
                );
                assert_eq!(
                    msg.tile_id, 63410,
                    "incorrect value for tile_id, expected 63410, is {}",
                    msg.tile_id
                );
                assert_eq!(
                    msg.tile_set_id, 48697,
                    "incorrect value for tile_set_id, expected 48697, is {}",
                    msg.tile_set_id
                );
            }
            _ => panic!("Invalid message type! Expected a MsgSsrTileDefinitionDepA"),
        };

        // Check payload is still identical
        let frame = sbp::to_vec(&sbp_msg).unwrap();
        assert_eq!(frame, payload.into_inner());
    }
}
